#include "gfx/legato/generated/le_gen_assets.h"

/*****************************************************************************
 * Legato String Table
 * Encoding        ASCII
 * Language Count: 1
 * String Count:   3
 *****************************************************************************/

/*****************************************************************************
 * string table data
 * 
 * this table contains the raw character data for each string
 * 
 * unsigned short - number of indices in the table
 * unsigned short - number of languages in the table
 * 
 * index array (size = number of indices * number of languages
 * 
 * for each index in the array:
 *   unsigned byte - the font ID for the index
 *   unsigned byte[3] - the offset of the string codepoint data in
 *                      the table
 * 
 * string data is found by jumping to the index offset from the start
 * of the table
 * 
 * string data entry:
 *     unsigned short - length of the string in bytes (encoding dependent)
 *     codepoint data - the string data
 ****************************************************************************/

const uint8_t stringTable_data[34] =
{
    0x03,0x00,0x01,0x00,0x00,0x10,0x00,0x00,0x00,0x16,0x00,0x00,0x00,0x1C,0x00,0x00,
    0x03,0x00,0x59,0x54,0x53,0x00,0x03,0x00,0x41,0x42,0x43,0x00,0x04,0x00,0x50,0x75,
    0x73,0x68,
};

/* font asset pointer list */
leFont* fontList[1] =
{
    (leFont*)&NotoSans_Regular,
};

const leStringTable stringTable =
{
    {
        LE_STREAM_LOCATION_ID_INTERNAL, // data location id
        (void*)stringTable_data, // data address pointer
        34, // data size
    },
    (void*)stringTable_data, // string table data
    fontList, // font lookup table
    LE_STRING_ENCODING_ASCII // encoding standard
};


// string list
leTableString string_YTS;
leTableString string_ABC;
leTableString string_Push;

void initializeStrings(void)
{
    leTableString_Constructor(&string_YTS, stringID_YTS);
    leTableString_Constructor(&string_ABC, stringID_ABC);
    leTableString_Constructor(&string_Push, stringID_Push);
}
